class Erzeuger extends Thread {

  private Puffer puffer;
	
  public Erzeuger (Puffer p)
    {puffer = p;}
	
  public void run() {
    for (int i = 0; i < 10; i++) {
	puffer.speichere(i);
      System.out.println(i + " produziert");
      } // Ende for
    } // Ende run

  } // Ende Erzeuger

class Verbraucher extends Thread {
	
  private Puffer puffer;

  public Verbraucher (Puffer p)
    {puffer = p;}
	
  public void run() {
    for (int i = 0; i < 10; i++) {
	int produkt = puffer.geholt();
	System.out.println(produkt + " verbraucht");
	} // Ende for
    } // Ende run

  } // Ende Verbraucher

class Puffer {

  private boolean istLeer = true;
  private int produkt;
	
  public synchronized void speichere (int x) {
    while (! istLeer) {
	try
	  {wait();}
	catch(InterruptedException e) {}
	} // Ende while
    produkt = x;
    istLeer = false;
    notify();
    } // Ende speichere
	
  public synchronized int geholt() {
    while (istLeer) {
      try
	  {wait();}
	catch(InterruptedException e) {}
	} // Ende while
    istLeer = true;
    notify();
    return produkt;
    } // Ende geholt

  } // Ende Puffer

public class ErzVerbrauch {
  public static void main (String[] xy) {
    Puffer puffer = new Puffer();
    new Verbraucher(puffer).start();
    new Erzeuger(puffer).start();
    } // Ende main
  } // Ende ErzVerbrauch
