class Parkhaus {

  private int pltze;
	
  public Parkhaus (int p) {
    if (p < 0) p = 0;
    pltze = p;
    } // Ende Konstruktor
	
  public synchronized void passieren() {
    // ins Parkhaus einfahren
    while (pltze == 0) {
      try
	  {wait();}
      catch(InterruptedException e) {}
      } // Ende while
    pltze--;
    } // Ende passieren
	
  public synchronized void verlassen() {
    // aus dem Parkhaus herausfahren
    pltze++; notify();
    } // Ende verlassen

  } // Ende Parkhaus

class Auto extends Thread {

  private Parkhaus parkhaus;
	
  public Auto (String name, Parkhaus p) {
    super(name); parkhaus = p;
    start();
    } // Ende Konstruktor
	
  public void run() {
    while (true) {
	try
	  {sleep((int) (Math.random()*10000));}
	catch(InterruptedException e) {}
	parkhaus.passieren();
	System.out.println(getName() + ": eingefahren");
	try
	  {sleep((int) (Math.random()*20000));}
	catch(InterruptedException e) {}
	parkhaus.verlassen();
	System.out.println(getName() + ": ausgefahren");
	} // Ende while
    } // Ende run

  } // Ende Auto

public class Parkbetrieb {

  public static void main (String[] xy) {
		
    Parkhaus parkhaus = new Parkhaus(10);
    for (int i = 1; i <= 40; i++)
	{Auto a = new Auto("Auto " + i, parkhaus);}
    } // Ende main

  } // Ende Parkbetrieb