class Konto {

  private float guthaben;
		
  public float Guthaben()
    {return guthaben;}

  public void setzGuthaben (float betrag)
    {guthaben = betrag;}

  } // Ende Konto

class Bank {

  private Konto[] konten;
	
  public Bank() {
    konten = new Konto[100];
    for (int i = 0; i < konten.length; i++)
	{konten[i] = new Konto();}
    } // Ende Konstruktor
	
  public synchronized void buche (int kontoNr, float betrag) {
    float alterStand = konten[kontoNr].Guthaben();
    float neuerStand = alterStand + betrag;
    konten[kontoNr].setzGuthaben(neuerStand);
    } // Ende buchen

  } // Ende Bank

class Angestellte extends Thread {

  private Bank bank;
	
  public Angestellte (String name, Bank b) {
    super(name); bank = b;
    start();
    } // Ende Konstruktor
	
  public void run() {
    for (int i = 0; i < 10000; i++) {
      int kontoNr = (int) Math.random() * 100;
	float betrag = (int) Math.random() * 1000 - 500;
	bank.buche(kontoNr, betrag);
	} // Ende for
    } // Ende run

  } // Ende Bankangestellte

public class Bankbetrieb {

  public static void main (String[] xy) {
		
    Bank sparkasse = new Bank();
    new Angestellte("Renate chsle", sparkasse);
    new Angestellte("Alice Schmidt", sparkasse);
    } // Ende main

  } // Ende Bankbetrieb